local addonname = ...
local addon = CreateFrame("Frame")
_G[addonname] = addon
addon.name = addonname
addon:SetScript("OnEvent", function(self, event, ...)
	local args={...}
	if event == "ADDON_LOADED" and args[1] == self.name then
		SavedCombatLogFilterSettings = SavedCombatLogFilterSettings or {}
		self.sVar = SavedCombatLogFilterSettings
	end
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if not self.sVar then return end
		for _, fdata in pairs(self.sVar) do
			local isFalse
			for argNum, value in pairs(fdata) do
				if type(value) == "string" and type(args[argNum]) == "string" then
					if not (args[argNum]:match(value) == args[argNum]) then
						isFalse = true
						break
					end
				else
					if not (args[argNum] == value) then
						isFalse = true
						break
					end
				end
			end
			if not isFalse then
				print("Combat log matched: ", unpack(args))
			end
		end
	end
end)
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SlashCmdList["CLOGFILTER"]=function(input)
	local cmd = input:match("%S+")
	if cmd == "list" then
		print("Combat log filter listing")
		for num, filterList in ipairs(addon.sVar) do
			local lString = ""
			for arg, value in pairs(filterList) do
				lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
			end
			print("Filter #"..num, lString)
		end
	elseif cmd == "remove" then
		local key = tonumber(input:match("%d+"))
		if addon.sVar[key] then
			local lString=""
			for arg, value in pairs(addon.sVar[key]) do
				lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
			end
			tremove(addon.sVar,key)
			print("Filter #"..key.." ("..lString..") deleted")
		end
	else
		local filterString = input:match("%S+(.+)")
		local this_t = {}
		for argString in input:gmatch("(%d+%=%\".-%\")") do
			local arg, stringpt = argString:match("(%d+)%=%\"(.-)%\"")
			arg = tonumber(arg)
			this_t[arg] = stringpt
		end
		for argNum in input:gmatch("(%d+%=%d+)") do
			local arg, num = argNum:match("(%d+)%=(%d+)")
			arg, num = tonumber(arg), tonumber(num)
			this_t[arg] = num
		end
		local lString=""
		for arg, value in pairs(this_t) do
			lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
		end
		tinsert(addon.sVar, this_t)
		print("Filter #"..(#addon.sVar).." created: "..lString)
	end
end
SLASH_CLOGFILTER1 = "/clogfilter"

--[[local function getchat()
	return GetRealNumRaidMembers()>0 and "RAID" or GetRealNumPartyMembers()>0 and "PARTY"
end
local a = CreateFrame("Frame")
a:SetScript("OnEvent", function(self, event, ...)
	self.pguid = self.pguid or UnitGUID("player")
	local args = {...}
	if (args[3] == self.pguid or args[6] == self.pguid) and args[9] == 47585 then
		local c = getchat()
		--if not c then return end
		if args[2]=="SPELL_AURA_APPLIED" then
			print("send start "..c)
			--SendChatMessage("Casting \124cff71d5ff\124Hspell:47585\124h[Dispersion]\124h\124r duration 6 Seconds", c)
		elseif args[2]=="SPELL_AURA_REMOVED" then
			print("send stop "..c)
			--SendChatMessage("\124cff71d5ff\124Hspell:47585\124h[Dispersion]\124h\124r" ended", c)
		end
	end
end)
a:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")--]]